parameter m_fname
*variable initiation
m_append_more = 1
m_esc = 2
m_pgup = 3
m_pgdwn = 4
strtfld = 1
endfld = 1
watslft = 1
rrow = 1
*lastkey() return values
k_pgdwn = 3
k_pgup = 18
k_esc = 27
k_ret = 13
*data type intitiation
m_no_logic = .t.
m_no_date = ctod("  /  /  ")
m_no_num = 0
clear
if (empty(m_fname))
   m_fname = space(8)
   @ 4, 2 say "Database Name" get m_fname
   read
endif
fille = upper(trim(m_fname)) + ".DBF"
if .not. file("&fille")
   ? chr(7)
   ? fille + " not found"
   return
endif
do append_some with m_fname
close databases
return    

*Procedure to call editing and appending functions
Procedure append_some
parameter m_fname
use &m_fname
m_nfields = num_fields()
do begstrtend
m_rec_no = lastrec() + 1
*Declare arrays
declare m_fnames[m_nfields]
declare m_data[m_nfields]
declare m_flen[m_nfields]
declare m_ftypes[m_nfields]
for m_field_no = 1 to m_nfields
   m_temp = field(m_field_no)
   m_ftypes[m_field_no] = type(m_temp)
   m_fnames[m_field_no] = m_temp
   do case
      case m_ftypes[m_field_no] = 'C'
           m_flen[m_field_no] = len(&m_temp)
      case m_ftypes[m_field_no] = 'N'
           m_flen[m_field_no] = 10
      case m_ftypes[m_field_no] = 'D'
           m_flen[m_field_no] = 8
      case m_ftypes[m_field_no] = 'L'
           m_flen[m_field_no] = 1
   endcase
next
go bottom
m_status = append_1()
do while (m_status <> m_esc)
   do case
      case m_status = m_append_more
         if endfld <> m_nfields
            do morstrtend
            m_status = edit_1(m_rec_no)
         else
            do begstrtend
            m_rec_no = m_rec_no + 1
            m_status = append_1()
         endif
      case m_status = m_pgup
         if strtfld <> 1
            strtfld = strtfld - 17
            endfld = strtfld + 16
            if endfld > m_nfields
               endfld = m_nfields
            endif
            m_status = edit_1(m_rec_no)
         else
            if (recno() > 1)
               m_rec_no = m_rec_no - 1
            endif
            do begstrtend
            m_status = edit_1(m_rec_no)
         endif
      case m_status = m_pgdwn
         if endfld <> m_nfields
            do morstrtend
            m_status = edit_1(m_rec_no)
         else 
            do begstrtend
            m_rec_no = m_rec_no + 1
            if (m_rec_no > lastrec())
               m_status = append_1()
            else
               m_status = edit_1(m_rec_no)
            endif
         endif
      otherwise
         m_status = m_esc
   endcase
enddo
return

*Procedure to determine ending field for screen display
procedure begstrtend
if m_nfields > 17
   strtfld = 1
   endfld = 17
else
   strtfld = 1
   endfld = m_nfields
endif
return

*Procedure to page to next batch of fields
procedure morstrtend
strtfld = endfld + 1
watslft = m_nfields - strtfld
if watslft > 17
   endfld = strtfld + 16
else
   endfld = m_nfields
endif
return

*Function to edit record number which is passed as a parameter
function edit_1
parameter m_rec_no
goto m_rec_no
clear
@ 1, 0 say "Record No. " + ltrim(str(m_rec_no))
rrow = 1
for m_field_no = strtfld to endfld
   m_temp = m_fnames[m_field_no]
   m_data[m_field_no] = &m_temp
   @ rrow + 3, 0 say m_fnames[m_field_no]
   @ rrow + 3, 11 get m_data[m_field_no]
   rrow = rrow + 1
next
read
if (updated())
   m_status = m_pgdwn
   for m_field_no = strtfld to endfld
      m_temp = m_fnames[m_field_no]
      replace &mtemp with m_data[m_field_no]
   next
else
   do case
      case lastkey() = k_esc
         m_status = m_esc
      case lastkey() = k_pgup
         m_status = m_pgup
      otherwise
         m_status = m_pgdwn
    endcase
endif
return(m_status)

*Function appends record if any fields are entered
function append_1
private m_status
clear
@ 1, 0 say "Record No. " + ltrim(str(m_rec_no))
rrow = 1
for m_field_no = strtfld to endfld
   m_temp = m_fnames[m_field_no]
   do case
      case m_ftypes[m_field_no] = 'C'
         m_data[m_field_no] = space(m_flen[m_field_no])
      case m_ftypes[m_field_no] = 'N'
         m_data[m_field_no] = m_no_num
      case m_ftypes[m_field_no] = 'D'
         m_data[m_field_no] = m_no_date
      case m_ftypes[m_field_no] = 'L'
         m_data[m_field_no] = m_no_logic
   endcase
   @ rrow + 3, 0 say m_fnames[m_field_no]
   @ rrow + 3, 11 get m_data[m_field_no]
   rrow = rrow + 1
next
read
if (updated())
   m_status = m_append_more
else
   do case
      case lastkey() = k_esc
         m_status = m_esc
      case lastkey() = k_pgup
         m_status = m_pgup
      case lastkey() = k_pgdwn
         m_status = m_esc
      otherwise
         m_status = m_esc
    endcase
endif
if(m_status = m_append_more)
   append blank
   for m_field_no = strtfld to endfld
      m_temp = m_fnames[m_field_no]
      replace &m_temp with m_data[m_field_no]
   next
endif
return(m_status)

*Function to determine number of fields in a record
function num_fields
private m_filed_no
m_field_no = 1
do while("" <> field(m_field_no))
   m_field_no = m_field_no + 1
enddo
m_field_no = m_field_no - 1
return(m_field_no)
*EOF append.prg


